xml-conduit-1.9.1.3: Pure-Haskell utilities for dealing with XML with the conduit package.

Safe Haskell | None
Language | Haskell2010

Text.XML.Stream.Render

Contents

- Rendering XML files
- Renderer settings
- Event rendering
- Attribute rendering

Description

`Enumeratee`s to render XML `Event`s. Unlike libxml-enumerator and expat-enumerator, this module does not provide IO and ST variants, since the underlying rendering operations are pure functions.

Synopsis

- renderBuilder :: forall (m :: Type -> Type). Monad m => RenderSettings -> ConduitT Event Builder m ()
- renderBuilderFlush :: forall (m :: Type -> Type). Monad m => RenderSettings -> ConduitT (Flush Event) (Flush Builder) m ()
- renderBytes :: forall (m :: Type -> Type). PrimMonad m => RenderSettings -> ConduitT Event ByteString m ()
- renderText :: forall (m :: Type -> Type). (PrimMonad m, MonadThrow m) => RenderSettings -> ConduitT Event Text m ()
- prettify :: forall (m :: Type -> Type). Monad m => ConduitT (Flush Event) (Flush Event) m ()
- data RenderSettings
- def :: Default a => a
- rsPretty :: RenderSettings -> Bool
- rsNamespaces :: RenderSettings -> [(Text, Text)]
- rsAttrOrder :: RenderSettings -> Name -> Map Name Text -> [(Name, Text)]
- rsUseCDATA :: RenderSettings -> Content -> Bool
- rsXMLDeclaration :: RenderSettings -> Bool
- orderAttrs :: [(Name, [Name])] -> Name -> Map Name Text -> [(Name, Text)]
- tag :: forall (m :: Type -> Type) i. Monad m => Name -> Attributes -> ConduitT i Event m () -> ConduitT i Event m ()
- content :: forall (m :: Type -> Type) i. Monad m => Text -> ConduitT i Event m ()
- data Attributes
- attr :: Name -> Text -> Attributes
- optionalAttr :: Name -> Maybe Text -> Attributes

# Rendering XML files

renderBuilder :: forall (m :: Type -> Type). Monad m => RenderSettings -> ConduitT Event Builder m () #

Render a stream of `Event`s into a stream of `Builder`s. Builders are from the blaze-builder package, and allow the create of optimally sized `ByteString`s with minimal buffer copying.

renderBuilderFlush :: forall (m :: Type -> Type). Monad m => RenderSettings -> ConduitT (Flush Event) (Flush Builder) m () #

Same as `renderBuilder` but allows you to flush XML stream to ensure that all events at needed point are rendered.

Since: 1.3.5

renderBytes :: forall (m :: Type -> Type). PrimMonad m => RenderSettings -> ConduitT Event ByteString m () #

Render a stream of `Event`s into a stream of `ByteString`s. This function wraps around `renderBuilder` and `builderToByteString`, so it produces optimally sized `ByteString`s with minimal buffer copying.

The output is UTF8 encoded.

renderText :: forall (m :: Type -> Type). (PrimMonad m, MonadThrow m) => RenderSettings -> ConduitT Event Text m () #

Render a stream of `Event`s into a stream of `Text`s. This function wraps around `renderBuilder`, `builderToByteString` and `renderBytes`, so it produces optimally sized `Text`s with minimal buffer copying.

prettify :: forall (m :: Type -> Type). Monad m => ConduitT (Flush Event) (Flush Event) m () #

Convert a stream of `Event`s into a prettified one, adding extra whitespace. Note that this can change the meaning of your XML.

# Renderer settings

data RenderSettings #

#### Instances

Instances details

Default RenderSettings # |
Instance details Defined in Text.XML.Stream.Render Methods def :: RenderSettings #

def :: Default a => a #

The default value for this type.

rsPretty :: RenderSettings -> Bool #

rsNamespaces :: RenderSettings -> [(Text, Text)] #

Defines some top level namespace definitions to be used, in the form of (prefix, namespace). This has absolutely no impact on the meaning of your documents, but can increase readability by moving commonly used namespace declarations to the top level.

rsAttrOrder :: RenderSettings -> Name -> Map Name Text -> [(Name, Text)] #

Specify how to turn the unordered attributes used by the Text.XML module into an ordered list.

rsUseCDATA :: RenderSettings -> Content -> Bool #

Determines if for a given text content the renderer should use a CDATA node.

Default: `False`

Since: 1.3.3

rsXMLDeclaration :: RenderSettings -> Bool #

Determines whether the XML declaration will be output.

Default: `True`

Since: 1.5.1

orderAttrs :: [(Name, [Name])] -> Name -> Map Name Text -> [(Name, Text)] #

Convenience function to create an ordering function suitable for use as the value of `rsAttrOrder`. The ordering function is created from an explicit ordering of the attributes, specified as a list of tuples, as follows: In each tuple, the first component is the `Name` of an element, and the second component is a list of attributes names. When the given element is rendered, the attributes listed, when present, appear first in the given order, followed by any other attributes in arbitrary order. If an element does not appear, all of its attributes are rendered in arbitrary order.

# Event rendering

tag #

Arguments

:: forall (m :: Type -> Type) i. Monad m |
=> Name |
-> Attributes |
-> ConduitT i Event m () | `Element'`s subnodes.
-> ConduitT i Event m () |

Generate a complete XML `Element`.

content :: forall (m :: Type -> Type) i. Monad m => Text -> ConduitT i Event m () #

Generate a textual `EventContent`.

# Attribute rendering

data Attributes #

A list of attributes.

#### Instances

Instances details

Monoid Attributes # |
Instance details Defined in Text.XML.Stream.Render Methods mempty :: Attributes # mappend :: Attributes -> Attributes -> Attributes # mconcat :: [Attributes] -> Attributes #
Semigroup Attributes # |
Instance details Defined in Text.XML.Stream.Render Methods (<>) :: Attributes -> Attributes -> Attributes # sconcat :: NonEmpty Attributes -> Attributes # stimes :: Integral b => b -> Attributes -> Attributes #

attr #

Arguments

:: Name | Attribute's name
-> Text | Attribute's value
-> Attributes |

Generate a single attribute.

optionalAttr :: Name -> Maybe Text -> Attributes #

Helper function that generates a valid attribute if input isn't `Nothing`, or `mempty` otherwise.